//+------------------------------------------------------------------+
//|                                                 LabTrend3_v2.mq4 |
//|                                  Copyright  2007, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2002, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Aqua
#property indicator_color2 Magenta




extern int    Risk      = 3;         // Sensivity Factor
extern double MoneyRisk = 2.0;       // Offset Factor
extern int    lookback  = 9;





double UpTrendBuffer[];
double DownTrendBuffer[];
double smax[];
double smin[];
double bsmax[];
double bsmin[];
double trend[];



int init()
{
   
   IndicatorBuffers(7); 
   SetIndexBuffer(0,UpTrendBuffer);   SetIndexStyle(0,DRAW_ARROW);  SetIndexArrow(0,159); SetIndexLabel(0,"UpTrend Stop");
   SetIndexBuffer(1,DownTrendBuffer); SetIndexStyle(1,DRAW_ARROW);  SetIndexArrow(1,159); SetIndexLabel(1,"DownTrend Stop");
   SetIndexBuffer(2,smin);
   SetIndexBuffer(3,smax);
   SetIndexBuffer(4,bsmin);
   SetIndexBuffer(5,bsmax);
   SetIndexBuffer(6,trend);
   
   IndicatorShortName("LabTrend3");

   return(0);
  }
  
  
  
int deinit() { return(0); }




int start()
  {
   
   double Kv=0.382;
   int    Length=10;      
   
   int counted_bars=IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   
   limit = MathMin(Bars-counted_bars,Bars-1);
   
   for(i=limit; i>=0; i--)
   {
     double Range=iATR(NULL,0,Length,i);
     double AvgRange=iATR(NULL,0,100,i);
     
     if (Range<AvgRange) Range=AvgRange;
     
     double high=High[Highest(NULL,0,MODE_HIGH,lookback,i)]; 
     double low =Low[Lowest(NULL,0,MODE_LOW,   lookback,i)];  
     
     smin[i]=low + 0.3*(high-low);
     smax[i]=high- 0.3*(high-low); 
     
     bsmax[i]=High[i]+(1.0+0.1*Risk)*Range;
	  bsmin[i]=Low[i] -(1.0+0.1*Risk)*Range;
	  
	  trend[i]=trend[i+1];   
	  if(Close[i]>smax[i])  trend[i]=1; 
     if(Close[i]<smin[i])  trend[i]=-1;
		 	
	  if(trend[i]>0)
	  {
	  if(Low[i]-bsmin[i]<Kv*MoneyRisk*Range) bsmin[i]=Low[i]-Kv*MoneyRisk*Range;
	  if(bsmin[i]<bsmin[i+1]) bsmin[i]=bsmin[i+1];
	  }
	  
	  if(trend[i]<0)
	  {
	  if(bsmax[i]-High[i]<Kv*MoneyRisk*Range) bsmax[i]=High[i]+Kv*MoneyRisk*Range;
	  if(bsmax[i]>bsmax[i+1]) bsmax[i]=bsmax[i+1];
	  }	  
	  	    
	  if (trend[i]>0) 
	  {
	     if (trend[i+1]<0)
	     {
	     bsmin[i]=Low[i]-0.1*Risk*Range;
	     UpTrendBuffer[i]=bsmin[i];
	     }
	     else
	     {
	     UpTrendBuffer[i]=bsmin[i];
	     }
	     DownTrendBuffer[i]=EMPTY_VALUE;
	     }
	  if (trend[i]<0) 
	  {
	     if (trend[i+1]>0)
	     {
	     bsmax[i]=High[i]+0.1*Risk*Range;
	     DownTrendBuffer[i]=bsmax[i];
	     }
	     else
	     {
	     DownTrendBuffer[i]=bsmax[i];
	     }
	     UpTrendBuffer[i]=EMPTY_VALUE;
	     }
	  
	 }
	return(0);	
 }

